#   Copyright (c) 2016, Xilinx, Inc.
#   All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions are met:
#
#   1.  Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#
#   2.  Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#
#   3.  Neither the name of the copyright holder nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
#   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
#   THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
#   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#   OR BUSINESS INTERRUPTION). HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
#   OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
#   ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


__author__ = "Yun Rock Qu"
__copyright__ = "Copyright 2017, Xilinx"
__email__ = "pynq_support@xilinx.com"


PYNQZ1_PMODA_SPECIFICATION = {'interface_width': 8,
                              'monitor_width': 64,
                              'traceable_outputs': {'D0': 0,
                                                    'D1': 1,
                                                    'D2': 2,
                                                    'D3': 3,
                                                    'D4': 4,
                                                    'D5': 5,
                                                    'D6': 6,
                                                    'D7': 7
                                                    },
                              'traceable_inputs': {'D0': 8,
                                                   'D1': 9,
                                                   'D2': 10,
                                                   'D3': 11,
                                                   'D4': 12,
                                                   'D5': 13,
                                                   'D6': 14,
                                                   'D7': 15
                                                   },
                              'traceable_tri_states': {'D0': 16,
                                                       'D1': 17,
                                                       'D2': 18,
                                                       'D3': 19,
                                                       'D4': 20,
                                                       'D5': 21,
                                                       'D6': 22,
                                                       'D7': 23
                                                       }
                              }
PYNQZ1_PMODB_SPECIFICATION = {'interface_width': 8,
                              'monitor_width': 64,
                              'traceable_outputs': {'D0': 0,
                                                    'D1': 1,
                                                    'D2': 2,
                                                    'D3': 3,
                                                    'D4': 4,
                                                    'D5': 5,
                                                    'D6': 6,
                                                    'D7': 7
                                                    },
                              'traceable_inputs': {'D0': 8,
                                                   'D1': 9,
                                                   'D2': 10,
                                                   'D3': 11,
                                                   'D4': 12,
                                                   'D5': 13,
                                                   'D6': 14,
                                                   'D7': 15
                                                   },
                              'traceable_tri_states': {'D0': 16,
                                                       'D1': 17,
                                                       'D2': 18,
                                                       'D3': 19,
                                                       'D4': 20,
                                                       'D5': 21,
                                                       'D6': 22,
                                                       'D7': 23
                                                       }
                              }
PYNQZ1_ARDUINO_SPECIFICATION = {'interface_width': 20,
                                'monitor_width': 64,
                                'traceable_outputs': {'A0': 0,
                                                      'A1': 1,
                                                      'A2': 2,
                                                      'A3': 3,
                                                      'A4': 4,
                                                      'A5': 5,
                                                      'D0': 6,
                                                      'D1': 7,
                                                      'D2': 8,
                                                      'D3': 9,
                                                      'D4': 10,
                                                      'D5': 11,
                                                      'D6': 12,
                                                      'D7': 13,
                                                      'D8': 14,
                                                      'D9': 15,
                                                      'D10': 16,
                                                      'D11': 17,
                                                      'D12': 18,
                                                      'D13': 19
                                                      },
                                'traceable_inputs': {'A0': 20,
                                                     'A1': 21,
                                                     'A2': 22,
                                                     'A3': 23,
                                                     'A4': 24,
                                                     'A5': 25,
                                                     'D0': 26,
                                                     'D1': 27,
                                                     'D2': 28,
                                                     'D3': 29,
                                                     'D4': 30,
                                                     'D5': 31,
                                                     'D6': 32,
                                                     'D7': 33,
                                                     'D8': 34,
                                                     'D9': 35,
                                                     'D10': 36,
                                                     'D11': 37,
                                                     'D12': 38,
                                                     'D13': 39,
                                                     },
                                'traceable_tri_states': {'A0': 42,
                                                         'A1': 43,
                                                         'A2': 44,
                                                         'A3': 45,
                                                         'A4': 46,
                                                         'A5': 47,
                                                         'D0': 48,
                                                         'D1': 49,
                                                         'D2': 50,
                                                         'D3': 51,
                                                         'D4': 52,
                                                         'D5': 53,
                                                         'D6': 54,
                                                         'D7': 55,
                                                         'D8': 56,
                                                         'D9': 57,
                                                         'D10': 58,
                                                         'D11': 59,
                                                         'D12': 60,
                                                         'D13': 61
                                                         }
                                }
